{ TWebLabel - by Haehnen
   This Component is FREEWARE!!!

 Goto: http://www.geocities.com/tokyo/bridge/3191/
 Mailto: haehnen@yahoo.com

 How to use:
  1. Put WebLabel on your Form.
  2. Choose you Link Typ ('http://','mailto:',...)
  3. Set your URL under the property 'Link'
  4. Enter the Caption
  5. Set Hover: True or False (Hover, what's that? The Hover function is like
     the function in MS Internet Explorer.
  6. Compile your project
  7. You can call the TWebLabel.ExeCute procedure or click on it.
  8. Have fun!

Maybe I add some 3D effects to the TWebLabel component        }

unit WebLabel;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ShellApi;

type
   TURLType = (lnFile, lnFtp, lnGopher, lnHttp, lnHttps,
              lnMailto, lnNews, lnTelnet, lnWais);

  TWebLabel = class(TLabel)
  private
   WLink: String;
   WLinkTyp: TURLType;
   WHover: Boolean;
   procedure SetLinkTyp(Value: TURLType);
   procedure SetHover(Value: Boolean);
   procedure HHMouseEnter(var Message: TMessage); message CM_MOUSEENTER;
   procedure HHMouseLeave(var Message: TMessage); message CM_MOUSELEAVE;

  protected

  public
   function Execute : Boolean;
   procedure Click; override;
   constructor Create(AOwner: TComponent);  override;

  published
    property Link : String read WLink
                           write WLink;

    property LinkTyp : TURLType read WLinkTyp
                                write SetLinkTyp;

    property Hover : Boolean read WHover
                            write SetHover;


  end;

procedure Register;

implementation

function TWebLabel.Execute;
var HyperLinkType: String;
begin
if Link = '' then  begin
HyperLinkType := 'http://';
WLink:='www.geocities.com/tokyo/bridge/3191/';
end
else
  case WLinkTyp of
       lnFile   : HyperlinkType := 'file://';          // what type do you wish?
       lnFtp    : HyperlinkType := 'ftp://';
       lnGopher : HyperlinkType := 'gopher://';
       lnHttp   : HyperlinkType := 'http://';
       lnHttps  : HyperlinkType := 'https://';
       lnMailto : HyperlinkType := 'mailto:';
       lnNews   : HyperlinkType := 'news:';
       lnTelnet : HyperlinkType := 'telnet:';
       lnWais   : HyperlinkType := 'wais:';
     end;
 ShellExecute(Application.Handle,PChar('open'),PChar(HyperLinkType+WLink),PChar(''),nil,SW_NORMAL);  //start Browser
end;

{Some Comments: If your delete 'if Link = '' then begin
                                ...' and 'case WlinkTyp of
                                            ...'
and the Link is '' then 'Shellexecute' will open 'C:\'  }

constructor TWebLabel.Create(AOwner: TComponent);
begin
inherited Create(AOwner);
Font.Color:=clBlue;              //Set when create`s
Font.Style:=[fsUnderline];
LinkTyp:=lnHttp;
Cursor:=crHandPoint;
Font.Size:=10;
end;

procedure TWebLabel.HHMouseLeave(var Message: TMessage);
begin
 if Hover = True then     //'OnMouseOut' then no Underline
  Font.Style:=[];
end;

procedure TWebLabel.HHMouseEnter(var Message: TMessage);
begin
 if Hover = True then          //'OnMoueseMove' then Underline
  Font.Style:=[fsUnderline];
end;

procedure TWebLabel.SetHover(Value: Boolean);
begin
 if Value <> WHover then
   WHover := Value;
  if Hover = True then                //Set the Hover effect
  Font.Style:=[] else
  Font.Style:=[fsUnderline];
end;

procedure TWebLabel.SetLinkTyp(Value: TURLType);
begin
 If Value <> WLinkTyp Then
     WLinkTyp := Value;          //what LinkTyp we have?
end;

procedure TWebLabel.Click;
begin
 Execute;          //Click, Click, Click,...
end;

procedure Register;
begin
  RegisterComponents('Web', [TWebLabel]);     //Register
end;             //   |
       // i have no problem when you change this
end.


//i hope you enjoy this component






//Note: This is my first component;)
